﻿/*
  Made By  © Mustafa López & el Rateret del Culebrón-Xinorlet Pinos (Alacant) 2019

  View -> https://harbour.github.io/doc/hbziparc.html
  View -> http://www.harbourdoc.com.br/show.asp?key=%22hbziparc.hbc%22
*/

*------------------------------------------------------------------------------*
#include <hmg.ch>
#include <hmg_BoxLetterShow.ch>
#include <hmg_GFilatov.ch>
#include <Demo_HB_Zip.prg>
#include <Demo_HB_UnZip.prg>
#include <Demo_UnZipSelec.prg>
#include <Decrypt_Tools.prg>
#include <Demo_Infus.prg>
#include <ViewPdf.prg>
#include <Viewry.prg>
#include <About.prg>
#include <Camely.prg>

*------------------------------------------------------------------------------*
FUNCTION Main()
*------------------------------------------------------------------------------*

 DECLARE WINDOW Main
 DECLARE WINDOW Form_1
 DECLARE WINDOW Form_2
 DECLARE WINDOW Form_3
 DECLARE WINDOW Form_4
 DECLARE WINDOW Form_5
 DECLARE WINDOW Form_6

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE OFF
  SET TOOLTIPSTYLE BALLOON
*----------------------------------*
  CLOSE DATABASES
*----------------------------------*
*---------------------------------------------------------------------------------------* 
 #pragma TEXTHIDDEN(1) 
    PUBLIC  cSenha := "Q65h3l8j41B"  // <- Very important not to change Password or Delete !!!                  
 #pragma TEXTHIDDEN(0) 
*---------------------------------------------------------------------------------------*
  PUBLIC  Tipx  := "*.*"
  PUBLIC  TipxX := "*.*"
  PUBLIC  nPos , cFile , lShowFileName 
  PUBLIC  aFiles, cDir, cPath
  PRIVATE HORAq  := RIGHT(TIME(), 4)                && <--------- Separa por Atras    
  PRIVATE HORAx  := STRTRAN(HORAq, ':')             && <--------- Eliminas los dos puntos(:) 
  PRIVATE dirax  := RIGHT( HORAx, 2) 
  
  PRIVATE Strin  := DTOC(DATE())
  PRIVATE Dchar  := DTOS(CTOD(Strin))
  PRIVATE cArya  := RIGHT( Dchar,1 ) + STRTRAN(TIME(),':') 
  PRIVATE pRova  := HORAx + cArya 
  PRIVATE pQrix  := STUFF( pRova , 1, 1, "8")    
  PRIVATE mirgy  := SUBSTR( pRova, 1, 1)    
*------------------------------------------------------------------------------------------------------------------*  
  PRIVATE PriNc  := HB_Curdrive() +":\"+Rtrim(Curdir() ) + "\"      && <------------- Directorio Principal
  PRIVATE DirXY  := HB_Curdrive() +":\"+Rtrim(Curdir() ) + "\"+"Compress_Zip\" 
  PRIVATE DirZY  := HB_Curdrive() +":\"+Rtrim(Curdir() ) + "\"+"Restore_UnZip\" 
*------------------------------------------------------------------------------------------------------------------*  
  PRIVATE cFileD , aDir , cPath  , ficXq  , aFiles 
  PRIVATE nLen   , Typo , firaax , NuevoT
  PRIVATE FDIA   , FDIAx ,HORA   , HORAx  ,HORYx , HORy 
  PRIVATE Date_Copy , Nome_Zip , AdireQ , rNum          
  PRIVATE nDirElemNo , aChecboQ,  aFoldery 

  PUBLIC  origenox , destinox 
  PRIVATE FicherA , Nuevo , mtable , passy , cCPass   
  PRIVATE m_appdir := GetStartUpFolder()
  PRIVATE cTargetFolder ,  aExtract  , aDirectory 
  PRIVATE cFileDx , cFileRx ,  aDir1x , aFolderyq
  PRIVATE cSourceZip := ""
*-----------------------------------------------------------------*
  PUBLIC nCtEfeito    := 0
  PUBLIC nCt          := 1
  PUBLIC cDescEfeito  := ""
  PUBLIC iFolny       := 0
*-----------------------------------------------------------------*  
*-----------------------------------------------------------------------------------------------------------------*    
IF ! FILE("CONTROL.DBF")
     NoEstaDBF()
ELSE
    CLOSE DATABASES
    SELECT 3   
    USE CONTROL NEW
    INDEX ON DATE_E TO Segury   
ENDIF
*-----------------------------------------------------------------------------------------------------------------*    
    CLOSE DATABASES

   DEFINE WINDOW Main                            ;
      AT 0,0                                     ;
      WIDTH 840 HEIGHT 680                       ;
      TITLE SPACE(2)+ "HB_ZIP_Demo Back-Up 2019" ; 
      ICON "Logo"                                ;
      BACKCOLOR {205,219,210}                    ; 
      MAIN NOMAXIMIZE NOMINIMIZE NOSIZE          ;
      ON INIT (NOCLOSEDLG(thiswindow.handle) )    

      ON KEY ESCAPE ACTION  Main.Release

      DEFINE MAIN MENU
           DEFINE POPUP 'C&reate Zip '
               ITEM "C&reate Zip"        ACTION  Create_New()               IMAGE 'Resource\Zip1.bmp' 
           END POPUP
           DEFINE POPUP 'R&estore Zip'
               ITEM "R&estore Zip"       ACTION  Restore_New()              IMAGE 'Resource\Zip2.bmp' 
           END POPUP
           DEFINE POPUP 'T&ools Select'
               ITEM "T&ools Selection"   ACTION  Restore_NewSelect()        IMAGE 'Resource\Imagen7x.bmp'   
           END POPUP
           DEFINE POPUP 'T&ools Pass '
               ITEM "T&ools Pass"        ACTION  ToolsPassword()            IMAGE 'Resource\Imagen8x.bmp'   
           END POPUP
           DEFINE POPUP 'V&iew Zip   '
               ITEM "V&iew Zip"          ACTION  VerBaseZip()               IMAGE 'Resource\View.bmp' 
           END POPUP
           DEFINE POPUP 'D&ocs       '
               ITEM "V&iew_Pdf"          ACTION  ViewPdf_EngSpa()           IMAGE 'Resource\Pdf.bmp'   
           END POPUP 
           DEFINE POPUP '&About      '
               ITEM "A&bout"             ACTION  AboutX()                   IMAGE 'Resource\Imagen6x.bmp'   
           END POPUP
           DEFINE POPUP '&Exit      '
               ITEM "E&xit"              ACTION  {||{ThisWindow.Release()}} IMAGE 'Resource\Exit.Bmp'     
           END POPUP
      END MENU

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 84,84 FONT "Arial" SIZE 9 FLAT BORDER         
                  
                                BUTTON Button_1ax                        ;
					CAPTION  ' C&reate Zip '         ;
					PICTURE  'Resource\Imagen1.bmp'  ;
					ACTION    Create_New()           ;     
                                        TOOLTIP  "Create Zip "           ;
                                        SEPARATOR AUTOSIZE                                  

				BUTTON Button_2ax                        ;
					CAPTION ' R&estore Zip '         ;
					PICTURE 'Resource\Imagen2.bmp'   ;
            			        ACTION   Restore_New()           ;
                                        TOOLTIP  "Restore Zip "          ;
                                        SEPARATOR AUTOSIZE                                    

                                BUTTON Button_3ax                        ;
					CAPTION ' T&ools Select'         ;
					PICTURE 'Resource\Imagen7.bmp'   ;
				        ACTION   Restore_NewSelect()     ; 
                                        TOOLTIP  "Tools Selection"       ; 
                                        SEPARATOR AUTOSIZE 

                                BUTTON Button_4ax                        ;
					CAPTION ' T&ools Pass  '         ;
					PICTURE 'Resource\Imagen8.bmp'   ;
				        ACTION   ToolsPassword()         ; 
                                        TOOLTIP  "Tools Password"        ; 
                                        SEPARATOR AUTOSIZE 	

				BUTTON Button_5ax                        ;
					CAPTION ' V&iew Zip    '         ;
					PICTURE 'Resource\Imagen3.bmp'   ;
				        ACTION   VerBaseZip()            ;
                                        TOOLTIP  "View Zip "             ;
                                        SEPARATOR AUTOSIZE 
                                     
                                BUTTON Button_6ax                        ;
					CAPTION ' D&ocs        '         ;
					PICTURE 'Resource\Imagen5.bmp'   ;
				        ACTION  ViewPdf_EngSpa()         ;
                                        TOOLTIP  "Docs "                 ;
                                        SEPARATOR AUTOSIZE    
                                                         
				BUTTON Button_7ax                        ;
					CAPTION ' A&bout       '         ;
					PICTURE 'Resource\Imagen6.bmp'   ;
				        ACTION  AboutX()                 ;  
                                        TOOLTIP  "About "                ;
                                        SEPARATOR AUTOSIZE          
                                                                                                                 
				BUTTON Button_8ax                        ;
					CAPTION ' E&xit        '        ;
					PICTURE  'Resource\Imagen9.bmp'  ;
					ACTION  {||{ThisWindow.Release()}}  ;  
                                        TOOLTIP  "Exit "                 ;
                                        SEPARATOR AUTOSIZE DROPDOWN				

					DEFINE DROPDOWN MENU BUTTON Button_8ax
                                               ITEM 'H&mg Vertion' ACTION InfusX()                    IMAGE 'Resource\Hmg.bmp'
                                               ITEM 'A&bout'       ACTION AboutX()                    IMAGE 'Resource\Imagen6x.bmp'   
                                               ITEM 'E&xit'        ACTION  {||{ThisWindow.Release()}} IMAGE 'Resource\Exit.Bmp'     
   					END MENU

			  END TOOLBAR
   
   END WINDOW
               
          SETWINDOWCURSOR ( Main.ToolBar_1.Handle, "Resource\SmoothHand.cur")    

   CENTER WINDOW  Main
   ACTIVATE WINDOW  Main

Return nil
*---------------------------------------------------------------------------------------------------------*

*----------------------------------------------------*
FUNCTION NoEstaDBF()
*----------------------------------------------------*
local aStru:={{"DIR_ZIP"  ,"C",60,0},;
              {"NOM_ZIP"  ,"C",60,0},;
              {"PASSWORD" ,"C",10,0},;
              {"FOLDER"   ,"L", 1,0},;
              {"DATE_E"   ,"D", 8,0},;
              {"TIME_E"   ,"C", 8,0},;
              {"UN_ZIP"   ,"L", 1,0},;
              {"DATE_S"   ,"D", 8,0},;
              {"TIME_S"   ,"C", 8,0}};

         REQUEST DBFCDX

         dbCreate( "Control.dbf", aStru, "DBFCDX", .T. )

  CLOSE DATABASES
  USE CONTROL NEW
  dbAppend()
  DELETE FOR DIR_ZIP = ""
  PACK
  CLOSE DATABASES
  USE CONTROL NEW
  INDEX ON DATE_E TO Segury  
             
RETURN NIL
*---------------------------------------------------------------------------------------------------------*

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._._.-._.-._._.-._.-._.-*

#pragma BEGINDUMP      //  Courtesy by  bpd2000  http://www.hmgforum.com/viewtopic.php?f=6&t=3880&p=35986&hilit=noclosedlg#p35986

#include "windows.h"
#include "hbapi.h"

HB_FUNC ( NOCLOSEDLG ) // ( hWnd )

{
   HMENU hMenu = GetSystemMenu( ( HWND ) hb_parnl( 1 ), FALSE ) ;
   EnableMenuItem( hMenu, SC_CLOSE, MF_GRAYED ) ;
}


HB_FUNC ( CLOSEDLG ) // ( hWnd ) MF_ENABLED

{
HMENU hMenu = GetSystemMenu( ( HWND ) hb_parnl( 1 ), FALSE ) ;
EnableMenuItem( hMenu, SC_CLOSE, MF_ENABLED ) ;
}

#pragma ENDDUMP

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._._.-._.-._._.-._.-._.-*















